import org.jblas.DoubleMatrix;
import org.jblas.FloatMatrix;

import org.shogun.modshogun;
import org.shogun.ShortRealMatrix;
import org.shogun.LongIntMatrix;
import org.shogun.WordMatrix;
import org.shogun.ByteMatrix;
import org.shogun.RealMatrix;
import org.shogun.IntMatrix;
import org.shogun.WrappedObjectArray;
import org.shogun.SerializableAsciiFile;
import org.shogun.BoolMatrix;

public class matrix_types {
static {
System.loadLibrary("modshogun");
}

public static void main(String argv[]) {
modshogun.init_shogun_with_defaults();

BoolMatrix bool_matrix = new BoolMatrix(2, 3);
bool_matrix.set_element(false, 0, 0);
bool_matrix.set_element(true, 1, 0);
bool_matrix.set_element(false, 0, 1);
bool_matrix.set_element(true, 1, 1);
bool_matrix.set_element(false, 0, 2);
bool_matrix.set_element(true, 1, 2);
boolean bool_element = bool_matrix.get_element(1, 0);
bool_matrix.set_element(bool_element, 0, 0);

DoubleMatrix byte_matrix = new DoubleMatrix(2, 3);
byte_matrix.put(0, 0, 0);
byte_matrix.put(1, 0, 1);
byte_matrix.put(0, 1, 0);
byte_matrix.put(1, 1, 1);
byte_matrix.put(0, 2, 0);
byte_matrix.put(1, 2, 1);
byte_matrix.put(0, 0, byte_matrix.get(1, 0));

DoubleMatrix word_matrix = new DoubleMatrix(2, 3);
word_matrix.put(0, 0, 0);
word_matrix.put(1, 0, 1);
word_matrix.put(0, 1, 0);
word_matrix.put(1, 1, 1);
word_matrix.put(0, 2, 0);
word_matrix.put(1, 2, 1);
word_matrix.put(0, 0, word_matrix.get(1, 0));

DoubleMatrix int_matrix = new DoubleMatrix(2, 3);
int_matrix.put(0, 0, 0);
int_matrix.put(1, 0, 1);
int_matrix.put(0, 1, 0);
int_matrix.put(1, 1, 1);
int_matrix.put(0, 2, 0);
int_matrix.put(1, 2, 1);
int_matrix.put(0, 0, int_matrix.get(1, 0));

DoubleMatrix long_int_matrix = new DoubleMatrix(2, 3);
long_int_matrix.put(0, 0, 0);
long_int_matrix.put(1, 0, 1);
long_int_matrix.put(0, 1, 0);
long_int_matrix.put(1, 1, 1);
long_int_matrix.put(0, 2, 0);
long_int_matrix.put(1, 2, 1);
long_int_matrix.put(0, 0, long_int_matrix.get(1, 0));

DoubleMatrix short_real_matrix = new DoubleMatrix(2, 3);
short_real_matrix.put(0, 0, 0.0f);
short_real_matrix.put(1, 0, 1.0f);
short_real_matrix.put(0, 1, 0.0f);
short_real_matrix.put(1, 1, 1.0f);
short_real_matrix.put(0, 2, 0.0f);
short_real_matrix.put(1, 2, 1.0f);
short_real_matrix.put(0, 0, short_real_matrix.get(1, 0));

DoubleMatrix real_matrix = new DoubleMatrix(2, 3);
real_matrix.put(0, 0, 0.1);
real_matrix.put(1, 0, 0.1);
real_matrix.put(0, 1, 0.1);
real_matrix.put(1, 1, 0.1);
real_matrix.put(0, 2, 0.1);
real_matrix.put(1, 2, 0.1);
real_matrix.put(0, 0, real_matrix.get(1, 0));

//LongRealMatrix long_real_matrix(2,3)
//long_real_matrix[0,0]=0.1
//long_real_matrix[1,0]=0.1
//long_real_matrix[0,1]=0.1
//long_real_matrix[1,1]=0.1
//long_real_matrix[0,2]=0.1
//long_real_matrix[1,2]=0.1
//long_real_matrix[0,0]=long_real_matrix[1,0]

// Serialize output for integration testing (automatically generated)
WrappedObjectArray __sg_storage = new WrappedObjectArray();
SerializableAsciiFile __sg_storage_file = new SerializableAsciiFile("matrix_types.dat", 'w');
__sg_storage.append_wrapped_real_matrix(real_matrix, "real_matrix");
__sg_storage.save_serializable(__sg_storage_file);

}
}
